﻿using System;
using System.Collections.Generic;
using General.Mediator;
using UnityEngine;
#if ADDRESSABLES
using UnityEngine.AddressableAssets;
#endif
using UnityEngine.Purchasing;

public interface IIAP : ISingleComponent
{
    public bool IsInitialized { get; }
    public bool Logger { get; set; }
    public Dictionary<string, Action<Product, Action<Product>>> PurchaseOrder { get; }
    public event Action<ProductCollection> Initialized;
    public event Action<string> InitializeFailed;
    public event Action<string> PurchaseSuccess;
    public event Action<PurchaseEventArgs> PurchaseSuccessWithArgs;
    public event Action<string> PurchaseFailed;
    public void InitializeViaConfig(ProductConfigWrapper productConfigWrapper);
    public void InitializeViaResources(string pathResources);
    public void InitializeViaResources(TextAsset textJson);
#if ADDRESSABLES
    public void InitializeViaAddressables(AssetReference assetReference);
#endif
    public void StartPurchase(string id,Action<Product, Action<Product>> verificationPurchase = null);
}