﻿using General.Mediator;
using UnityEngine;

namespace IAP
{
    internal class IAPComponent : MonoBehaviour
    {
        #region Fields

        private  IIAP instance;
        public bool dontDestroyOnLoadOnEnable;
        public bool removeInstanceOnDestroy; 

        #endregion

        #region Unity Lifecycle

        private void Awake()
        {
            if (dontDestroyOnLoadOnEnable)
            {
                DontDestroyOnLoad(this);
            }
            Init();
            MC.Add(instance);
        }

        private void OnDestroy()
        {
            if (removeInstanceOnDestroy) instance = null;
        }

        #endregion

        #region Methods

        private void Init() => instance = new IAPProvider();

        #endregion
    }
}